"use strict";
// import type {I18n} from 'vue-i18n'
Object.defineProperty(exports, "__esModule", { value: true });
exports.createApalize = void 0;
const tslib_1 = require("tslib");
const apalize_js_1 = tslib_1.__importDefault(require("apalize.js"));
const createApalize = (config) => {
    return {
        install: (app) => {
            const init_mount = app.mount;
            app.mount = (containerOrSelector) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                if (!(config === null || config === void 0 ? void 0 : config.i18n))
                    return;
                const apalize = yield (0, apalize_js_1.default)({
                    application_id: config.application_id,
                    host: config.host
                });
                const translations = convertToVueI18n(apalize.translations);
                Object.keys(translations).forEach(locale => {
                    var _a;
                    (_a = config === null || config === void 0 ? void 0 : config.i18n) === null || _a === void 0 ? void 0 : _a.global.setLocaleMessage(locale, translations[locale]);
                });
                const t = config.i18n.global.t;
                config.i18n.global.t = (key, ...values) => {
                    // @ts-ignore
                    const translation = t(key, ...values);
                    if (apalize)
                        apalize.translate(key);
                    return translation;
                };
                return init_mount(containerOrSelector);
            });
        }
    };
};
exports.createApalize = createApalize;
const convertToVueI18n = (translations) => {
    const messages = {};
    translations.forEach(translation => {
        const values = translation.values;
        values.forEach(value => {
            if (!messages[value.locale]) {
                messages[value.locale] = {};
            }
            const keys = translation.key.split(".");
            let obj = messages[value.locale];
            for (let i = 0; i < keys.length; i++) {
                if (i === keys.length - 1) {
                    obj[keys[i]] = value.value;
                }
                else {
                    if (!obj[keys[i]]) {
                        obj[keys[i]] = {};
                    }
                    obj = obj[keys[i]];
                }
            }
        });
    });
    return messages;
};
//# sourceMappingURL=index.js.map